Unit aeb5e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure aeb5e(NM :Integer; N :Integer; M1 :Integer;
                var B :Array of Extended; L1 :Integer; L2 :Integer;
                var EV :Array of Extended; var EPS :Array of Extended;
                var C :Array of Extended);

implementation

procedure aeb5e(NM :Integer; N :Integer; M1 :Integer;
                var B :Array of Extended; L1 :Integer; L2 :Integer;
                var EV :Array of Extended; var EPS :Array of Extended;
                var C :Array of Extended);
var
M,L0,M2,M21,I,J,I1,K1,M0,L,LI,IDEL,NUM,JLN1,IP,K,MET,J1 :Integer;
XMIN,XMAX,R,EPS0,XL,XU,EPS1,X0,D,RI :Extended;
const
RELMCH :Extended = 1.111307226797642e-16;
label
_2,_3,_4,_5,_6,_10,_11,_14,_15,_20,_25,_30,_35,_40,_60,_70,_80,_50,
_90,_95,_140,_150,_155,_160,_170,_180,_190,_120,_130,_200,_205,_206,
_210,_220;
begin
M := M1-1;
L0 := Abs(L2-L1)+1;
{  B-E PAH EPOPHA }
XMIN := B[0+(M1-1)*NM];
XMAX := B[0+(M1-1)*NM];
for I:=1 to N do
 begin
  M0 := Max0(1,M1-I+1);
  R := 0.e0;
  if ( M0 = M1 )
   then goto _3;
  for J:=M0 to M do
   begin
    R := R+Abs(B[(I-1)+(J-1)*NM]);
_2:
   end;
_3:
  M0 := Min0(M,N-I);
  if ( M0 = 0 )
   then goto _5;
  for J:=1 to M0 do
   begin
    I1 := I+J;
    K1 := M1-J;
    R := R+Abs(B[(I1-1)+(K1-1)*NM]);
_4:
   end;
_5:
  XMIN := EMin1(XMIN,B[(I-1)+(M1-1)*NM]-R);
  XMAX := EMax1(XMAX,B[(I-1)+(M1-1)*NM]+R);
_6:
 end;
R := EMax1(Abs(XMIN),Abs(XMAX));
EPS0 := R*RELMCH;
if ( EPS0 = 0.e0 )
 then EPS0 := RELMCH;
{  B-E HAOEO C.H.  CKOMO PY }
LI := L2;
L := L0;
IDEL := 1;
if ( L2 < L1 )
 then LI := L1;
if ( L2 < L1 )
 then L := 1;
if ( L2 < L1 )
 then IDEL := -1;
XL := XMIN;
XU := XMAX;
MET := 10;
goto _14;
_10:
XL := XMIN;
XMAX := XU;
{  B-E HAMEHEO C.H.  CKOMO PY }
LI := L1;
L := 1;
if ( L1 = L2 )
 then goto _220;
if ( L2 < L1 )
 then LI := L2;
if ( L2 < L1 )
 then L := L0;
MET := 11;
goto _14;
{  B-E OCTAHX C.H. }
_11:
L := L+IDEL;
LI := LI+1;
if ( LI = Max0(L1,L2) )
 then goto _220;
_14:
XU := XMAX;
EPS1 := EMax1(EPS[L-1],EPS0);
EPS[L-1] := EPS1;
_15:
X0 := (XL+XU)*0.5e0;
if ( Abs(XU-XL) <= 2.e0*RELMCH*(Abs(XU)+Abs(XL))
     +EPS1 )
 then goto _210;
for K:=1 to M1 do
 begin
  K1 := K-1;
  I1 := M1-K1;
  M0 := Min0(M,N-K1);
  for I:=1 to M0 do
   begin
    J := I+K1;
    C[(I-1)+(J-1)*M1] := B[(J-1)+(I1-1)*NM];
_20:
   end;
_25:
 end;
M0 := Min0(M,N-M1);
M21 := M1+M0;
for I:=1 to M0 do
 begin
  J1 := I+M1;
  for J:=J1 to M21 do
   begin
    C[(I-1)+(J-1)*M1] := 0.e0;
_30:
   end;
 end;
for I:=1 to M do
 begin
  for J:=1 to I do
   begin
    C[(I-1)+(J-1)*M1] := C[(J-1)+(I-1)*M1];
_35:
   end;
  C[(I-1)+(I-1)*M1] := C[(I-1)+(I-1)*M1]-X0;
_40:
 end;
JLN1 := LI-N;
NUM := 0;
if ( Abs(C[0+0*M1]) < EPS0 )
 then C[0+0*M1] := EPS0;
if ( C[0+0*M1] < 0.e0 )
 then NUM := 1;
if ( NUM = LI )
 then goto _205;
if ( NUM = JLN1 )
 then goto _206;
if ( M = 1 )
 then goto _95;
for I:=2 to M do
 begin
  JLN1 := JLN1+1;
  I1 := I-1;
  IP := 1;
  M2 := I+Min0(M,N-I);
  for K:=1 to I1 do
   begin
    R := C[(I-1)+(K-1)*M1];
    D := C[(K-1)+(K-1)*M1];
    if ( Abs(D) > Abs(R) )
     then goto _70;
    if ( R = 0.e0 )
     then goto _50;
    for J:=K to M2 do
     begin
      RI := C[(I-1)+(J-1)*M1];
      C[(I-1)+(J-1)*M1] := C[(K-1)+(J-1)*M1];
      C[(K-1)+(J-1)*M1] := RI;
_60:
     end;
    if ( Sign(1.e0,R) = Sign(1.e0,D) )
     then IP := -IP;
_70:
    RI := C[(I-1)+(K-1)*M1]/C[(K-1)+(K-1)*M1];
    K1 := K+1;
    for J:=K1 to M2 do
     begin
      C[(I-1)+(J-1)*M1] := C[(I-1)+(J-1)*M1]-RI*C[(K-1)+(J-1)*M1];
_80:
     end;
    C[(I-1)+(K-1)*M1] := 0.e0;
_50:
   end;
  if ( Abs(C[(I-1)+(I-1)*M1]) < EPS0 )
   then C[(I-1)+(I-1)*M1] := EPS0;
  if ( C[(I-1)+(I-1)*M1] < 0.e0 )
   then IP := -IP;
  if ( IP = -1 )
   then NUM := NUM+1;
  if ( NUM = LI )
   then goto _205;
  if ( NUM = JLN1 )
   then goto _206;
_90:
 end;
_95:
for K:=M1 to N do
 begin
  JLN1 := JLN1+1;
{  OPM-E OCEHE CTPOK MACCBA C }
  for J:=1 to M1 do
   begin
    C[(M1-1)+(J-1)*M1] := B[(K-1)+(J-1)*NM];
_140:
   end;
  M0 := Min0(M,N-K);
  M21 := M1+M0;
  M2 := M+M0;
  if ( N = K )
   then goto _155;
  for J:=1 to M0 do
   begin
    K1 := K+J;
    I := J+M1;
    I1 := M1-J;
    C[(M1-1)+(I-1)*M1] := B[(K1-1)+(I1-1)*NM];
_150:
   end;
_155:
  C[(M1-1)+(M1-1)*M1] := C[(M1-1)+(M1-1)*M1]-X0;
{  METO AYCCA }
  IP := 1;
  for I:=1 to M do
   begin
    D := C[(I-1)+(I-1)*M1];
    R := C[(M1-1)+(I-1)*M1];
    if ( Abs(D) > Abs(R) )
     then goto _170;
    if ( R = 0.e0 )
     then goto _190;
    for J:=I to M21 do
     begin
      RI := C[(I-1)+(J-1)*M1];
      C[(I-1)+(J-1)*M1] := C[(M1-1)+(J-1)*M1];
      C[(M1-1)+(J-1)*M1] := RI;
_160:
     end;
    if ( Sign(1.e0,R) = Sign(1.e0,D) )
     then IP := -IP;
_170:
    RI := C[(M1-1)+(I-1)*M1]/C[(I-1)+(I-1)*M1];
    I1 := I+1;
    for J:=I1 to M21 do
     begin
      C[(M1-1)+(J-1)*M1] := C[(M1-1)+(J-1)*M1]-RI*C[(I-1)+(J-1)*M1];
_180:
     end;
    C[(M1-1)+(I-1)*M1] := 0.e0;
_190:
   end;
  if ( Abs(C[(M1-1)+(M1-1)*M1]) < EPS0 )
   then C[(M1-1)+(M1-1)*M1] := EPS0;
  if ( C[(M1-1)+(M1-1)*M1] < 0.e0 )
   then IP := -IP;
  if ( IP = -1 )
   then NUM := NUM+1;
  if ( NUM = LI )
   then goto _205;
  if ( NUM = JLN1 )
   then goto _206;
{  OPM-E HOBO C }
  for I:=1 to M do
   begin
    I1 := I+1;
    for J:=I to M2 do
     begin
      C[(I-1)+(J-1)*M1] := C[(I1-1)+(J+0)*M1];
_120:
     end;
    C[(I-1)+(M21-1)*M1] := 0.e0;
_130:
   end;
_200:
 end;
_205:
XU := X0;
goto _15;
_206:
XL := X0;
goto _15;
_210:
EV[L-1] := X0;
if ( MET=10 ) then goto _10 else
if ( MET=11 ) then goto _11;
_220:
end;

end.
